/****************************************************************************/
/* SELFISHDETOUR:selfishdetour-info */
/*     This file is part of Selfish Detour: OS detour(noise) benchmark
 */
/* SELFISHDETOUR:selfishdetour-info */
/* */
/* SELFISHDETOUR:selfishdetour-fillin */
/*     $Id: selfish_detour.h,v 1.12 2007/01/03 21:16:49 kazutomo Exp $
 *     SelfishDetour_Version: 1.0.7
 *     SelfishDetour_Heredity: FOSS_ORIG
 *     SelfishDetour_License: GPL
 */
/* SELFISHDETOUR:selfishdetour-fillin */
/* */
/* SELFISHDETOUR:selfishdetour-gpl */
/*      Copyright: Argonne National Laboratory, Department of Energy,
 *                 and University of Chicago.  2004, 2005, 2006, 2007
 *      SelfishDetour License: GPL
 * 
 *      This software is free.  See the file license-files/license.GPL
 *      for complete details on your rights to copy, modify, and use this
 *      software.
 */
/* SELFISHDETOUR:selfishdetour-gpl */
/****************************************************************************/
#ifndef __SELFISH_DETOUR_H_DEFINED__
#define __SELFISH_DETOUR_H_DEFINED__

#include "selfish_utils.h"



void get_detour_stats( double * bogoflop, 
		       unsigned long long* counter,
		       unsigned long long* elapsed_ticks);

double get_detour_noise_interval_usec();
double get_detour_noise_probability();
double get_detour_noise_duration_usec();
int get_detour_noise_counter();
int get_detour_noise_sync();


void reset_detour_stats();

void selfish_detour_init();

void selfish_detour_init_params(double interval_usec, 
				double duration_usec,
				double probability,
				int counter,
				int sync ) ;

void selfish_detour_finalize();


extern volatile int      selfish_detour_playback_finished;
extern volatile int      selfish_detour_playback_cnt;
extern volatile uint64_t selfish_detour_playback_elapsed;

void read_selfish_detour_data(const char* filename);

void selfish_detour_playback_init(void);
void selfish_detour_playback_finalize(void);

unsigned selfish_detour_get_signal_overhead_ticks();


#endif

