/****************************************************************************/
/* SELFISHDETOUR:selfishdetour-info */
/*     This file is part of Selfish Detour: OS detour(noise) benchmark
 */
/* SELFISHDETOUR:selfishdetour-info */
/* */
/* SELFISHDETOUR:selfishdetour-fillin */
/*     $Id: selfish_detour_example.c,v 1.4 2007/01/03 21:16:49 kazutomo Exp $
 *     SelfishDetour_Version: 1.0.7
 *     SelfishDetour_Heredity: FOSS_ORIG
 *     SelfishDetour_License: GPL
 */
/* SELFISHDETOUR:selfishdetour-fillin */
/* */
/* SELFISHDETOUR:selfishdetour-gpl */
/*      Copyright: Argonne National Laboratory, Department of Energy,
 *                 and University of Chicago.  2004, 2005, 2006, 2007
 *      SelfishDetour License: GPL
 * 
 *      This software is free.  See the file license-files/license.GPL
 *      for complete details on your rights to copy, modify, and use this
 *      software.
 */
/* SELFISHDETOUR:selfishdetour-gpl */
/****************************************************************************/
/*
  Example, inserting selfish_detour into code

  Pete Beckman
*/

#include <stdio.h>
#include <stdlib.h>
#include "mpi.h"
#include "selfish_detour.h"


int main(int argc, char* argv[]) 
{
  unsigned long i,j;
  unsigned long long t1,t2;
  int rank;

  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);

  selfish_detour_init();  
  /*
    Use selfish env. variable to change noise injection pattern.  Here
    is an example usage.
    
    cqsub -q short -n 32 -t 10 -e
    SELFISH_I=1000:SELFISH_P=1.0:SELFISH_D=20 ./selfish_detour_example

    1000 usec interval,20 usec duration and  1.0 probability

    See README for env. variable.
  */

  if(rank==0) printf("Starting computation\n");
  j=0;
  t1=rdtsc();
  for (i=0; i<1000000000; i++)    j = i+j;   /* fix amount of work */
  t2=rdtsc();
  if(rank==0) printf("Ending computation: %lu \n",j); 
  if(rank==0) printf("%f sec @ rank=0\n",
		     (double)(t2-t1)/(double)TICKS_PER_US/1000.0/1000.0 );

  selfish_detour_finalize();

  return 0;
}
