//***************************************************************************
// SELFISHDETOUR:selfishdetour-info
//     This file is part of Selfish Detour: OS detour(noise) benchmark
// SELFISHDETOUR:selfishdetour-info
//
// SELFISHDETOUR:selfishdetour-fillin
//     $Id: AnalyzeDetour.h,v 1.8 2007/01/03 21:16:49 kazutomo Exp $
//     SelfishDetour_Version: 1.0.7
//     SelfishDetour_Heredity: FOSS_ORIG
//     SelfishDetour_License: GPL
// SELFISHDETOUR:selfishdetour-fillin
//
// SELFISHDETOUR:selfishdetour-gpl
//      Copyright: Argonne National Laboratory, Department of Energy,
//                 and University of Chicago.  2004, 2005, 2006, 2007
//      SelfishDetour License: GPL
// 
//      This software is free.  See the file license-files/license.GPL
//      for complete details on your rights to copy, modify, and use this
//      software.
// SELFISHDETOUR:selfishdetour-gpl
//***************************************************************************

#ifndef __ANALYZEDETOUR_DEFINED__ 
#define __ANALYZEDETOUR_DEFINED__


#include <iostream>
#include <string>


class AnalyzeDetourOptions {
public:
  AnalyzeDetourOptions( int argc, char* argv[] );
  ~AnalyzeDetourOptions() {}

  void usage() const;

  const std::string& progname() const { return progname_m; }
  const std::string& datafn()   const { return datafn_m; }
  const std::string& outputbn() const { return outputbn_m; }
  const bool enableSimulation() const { return enableSimulation_m; }

  const int verbose() const { return verbose_m; }

private:
  std::string progname_m;
  std::string datafn_m;  // data file name 
  std::string outputbn_m; 
  bool enableSimulation_m;
  int verbose_m;
};

#endif
