//***************************************************************************
// SELFISHDETOUR:selfishdetour-info
//     This file is part of Selfish Detour: OS detour(noise) benchmark
// SELFISHDETOUR:selfishdetour-info
//
// SELFISHDETOUR:selfishdetour-fillin
//     $Id: UniRand.h,v 1.3 2007/01/03 21:16:49 kazutomo Exp $
//     SelfishDetour_Version: 1.0.7
//     SelfishDetour_Heredity: FOSS_ORIG
//     SelfishDetour_License: GPL
// SELFISHDETOUR:selfishdetour-fillin
//
// SELFISHDETOUR:selfishdetour-gpl
//      Copyright: Argonne National Laboratory, Department of Energy,
//                 and University of Chicago.  2004, 2005, 2006, 2007
//      SelfishDetour License: GPL
// 
//      This software is free.  See the file license-files/license.GPL
//      for complete details on your rights to copy, modify, and use this
//      software.
// SELFISHDETOUR:selfishdetour-gpl
//***************************************************************************

#ifndef __UNIRAND_H_DEFINED__
#define __UNIRAND_H_DEFINED__

#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

/**
 * UniRand is a wrapper class for erand48()
 * Random initializtion is done at the class constructor
 * return a random value which is uniformly distributed between [0.0,1.0)
 */

class UniRand
{
public:
  UniRand() {
    int fd = open("/dev/urandom", O_RDONLY);
    if( fd < 0 ) {
      xsubi[0] = xsubi[1] = xsubi[2] = 0;
      std::cout << "unable to open /dev/urandom" << std::endl;
    } else {
      int cnt = sizeof(xsubi);
      if( cnt!=read(fd, (void*)xsubi,cnt) ) {
	std::cout << "warning: unable to initilize random" << std::endl;
      }
      close(fd);
    }
  }
  ~UniRand() {}

  double rand() {
    return erand48(xsubi); 
  }
private:
  unsigned short xsubi[3];

};



#endif





