#!/bin/sh

#***************************************************************************
# SELFISHDETOUR:selfishdetour-info
#      This file is part of Selfish Detour: OS detour(noise) benchmark
# SELFISHDETOUR:selfishdetour-info
#
# SELFISHDETOUR:selfishdetour-fillin
#      $Id: analyzer.sh,v 1.8 2007/01/03 21:16:49 kazutomo Exp $
#      SelfishDetour_Version: 1.0.7
#      SelfishDetour_Heredity: FOSS_ORIG
#      SelfishDetour_License: GPL
# SELFISHDETOUR:selfishdetour-fillin
#
# SELFISHDETOUR:selfishdetour-gpl
#       Copyright: Argonne National Laboratory, Department of Energy,
#                  and University of Chicago.  2004, 2005, 2006, 2007
#       SelfishDetour License: GPL
#  
#       This software is free.  See the file license-files/license.GPL
#       for complete details on your rights to copy, modify, and use this
#       software.
# SELFISHDETOUR:selfishdetour-gpl
#***************************************************************************

basedir=`dirname $0`
cwd=`cd ${basedir} ; pwd`

if [ -z "$1" ] ; then
    echo "Usage: topdir b|g|s|e"
    exit 1
fi

topdir=$1
shift

ANALYZETOOL=${cwd}/AnalyzeDetour
MK3DGRAPH=${cwd}/mk-3dgraph.sh
MK2DGRAPH=${cwd}/mk-2dgraph.sh

DATA_DIR=${topdir}
OUTPUT_DIR=${topdir}/output

if [ ! -e ${ANALYZETOOL} ] ; then
	make
fi


echo "check ${OUTPUT_DIR}"
if [ ! -d "${OUTPUT_DIR}" ] ; then
    mkdir ${OUTPUT_DIR}
fi

if [ ! -e ${ANALYZETOOL} ] ; then
    echo "${ANALYZETOOL} does not exist"
    echo "compile it first"
    exit 1
fi


cmdflag=$1
shift

case $cmdflag in
t) echo test - show target dataname ;;
b) echo basic stats and graph ;;
g) echo graph ;;
s) echo simulation ;;
e) echo etc ;;
*) echo "Usage: $0 topdir b|g|s|e" ; exit 1 ;;
esac


#
# ${DATA_DIR}/detour-*.dat  are going to be target data set
#

#for i in ${DATA_DIR}/detour-*.dat ; do
#   bn=`basename $i|sed -e s/\.dat$//|sed -e s/^detour-//`


while [ ! -z "$1" ] ; do
bn=$1
shift

file="${DATA_DIR}/detour-$bn.dat"



case $cmdflag in
t)
   echo  "$bn"
;;
b)
   echo "making basic stats $file ..."
   ${ANALYZETOOL}  -v -i $file -b ${OUTPUT_DIR}/res-${bn}
;;
s)
# do all calculation
   echo "analyzing $file ..."
   ${ANALYZETOOL}  -v -s -i $file -b ${OUTPUT_DIR}/res-${bn}
;;
g)
   echo "making graph $file ..."

   ${MK3DGRAPH} ${OUTPUT_DIR}/res-${bn}-3d.dat ${bn}
   ${MK2DGRAPH} ${OUTPUT_DIR}/res-${bn}-2d.dat ${bn}
;;
esac

done

exit 0;

