#!/usr/bin/perl

#***************************************************************************
# SELFISHDETOUR:selfishdetour-info
#      This file is part of Selfish Detour: OS detour(noise) benchmark
# SELFISHDETOUR:selfishdetour-info
#
# SELFISHDETOUR:selfishdetour-fillin
#      $Id: convert-walltime-from-tick.pl,v 1.3 2007/01/03 21:16:49 kazutomo Exp $
#      SelfishDetour_Version: 1.0.7
#      SelfishDetour_Heredity: FOSS_ORIG
#      SelfishDetour_License: GPL
# SELFISHDETOUR:selfishdetour-fillin
#
# SELFISHDETOUR:selfishdetour-gpl
#       Copyright: Argonne National Laboratory, Department of Energy,
#                  and University of Chicago.  2004, 2005, 2006, 2007
#       SelfishDetour License: GPL
#  
#       This software is free.  See the file license-files/license.GPL
#       for complete details on your rights to copy, modify, and use this
#       software.
# SELFISHDETOUR:selfishdetour-gpl
#***************************************************************************


# this filter is used to convert value in record_selfish_detour
# which is in tick to walltime.
 

my $cpufreq=0;

while(<STDIN>) {
   print $_;
   if( /^# CPU_FREQ_HZ=([0-9]+)/ ) {
       $cpufreq=$1; 
       last;
   }
}

print "#\n";
print "#  detour         detour\n";
print "#  start(sec)     duration(sec)\n";
if( $cpufreq == 0 ) {
   die "Unable to read the cpu freq value";
   exit(1);
}


while(<STDIN>) {
   chomp;
   if( /^([0-9]+)\s+([0-9]+)/ ) {
       my $st = $1;
       my $de = $2;
       $st = $st / $cpufreq;
       $de = $de / $cpufreq; 
       print "$st $de\n";
   }
}

exit 0

