#!/bin/sh

#***************************************************************************
# SELFISHDETOUR:selfishdetour-info
#      This file is part of Selfish Detour: OS detour(noise) benchmark
# SELFISHDETOUR:selfishdetour-info
#
# SELFISHDETOUR:selfishdetour-fillin
#      $Id: mk-2dgraph.sh,v 1.5 2007/01/03 21:16:49 kazutomo Exp $
#      SelfishDetour_Version: 1.0.7
#      SelfishDetour_Heredity: FOSS_ORIG
#      SelfishDetour_License: GPL
# SELFISHDETOUR:selfishdetour-fillin
#
# SELFISHDETOUR:selfishdetour-gpl
#       Copyright: Argonne National Laboratory, Department of Energy,
#                  and University of Chicago.  2004, 2005, 2006, 2007
#       SelfishDetour License: GPL
#  
#       This software is free.  See the file license-files/license.GPL
#       for complete details on your rights to copy, modify, and use this
#       software.
# SELFISHDETOUR:selfishdetour-gpl
#***************************************************************************

if [ -z "$1" ] ; then 
  echo "Usage: $0 datafile title"
  exit 1 
fi

datafile=${1}
dataname=`echo ${datafile}|sed -e 's/\.dat$//'` 

if [ ! -f ${datafile} ] ; then
   echo  "could not find ${datafile}"
   exit 1;
fi


title=${dataname}
if [ ! -z "$2" ] ; then
  title=$2
fi


cat - > a.gnu <<EOF
set terminal png 
set output "${dataname}.png"

set title "$title"

set xlabel "Sync.Freq. [HZ] - logscale"
set ylabel "( AV of (max-min) ) / Q"

set logscale x

pl \
"${datafile}" using 1:3:4   w errorlines title "#nodes=2", \
"${datafile}" using 1:6:7   w errorlines title "#nodes=16", \
"${datafile}" using 1:9:10  w errorlines title "#nodes=256", \
"${datafile}" using 1:12:13 w errorlines title "#nodes=4k", \
"${datafile}" using 1:15:16 w errorlines title "#nodes=64k", \
"${datafile}" using 1:18:19 w errorlines title "#nodes=100k"

repl
EOF

gnuplot a.gnu

rm -f a.gnu

