#!/bin/sh

#***************************************************************************
# SELFISHDETOUR:selfishdetour-info
#      This file is part of Selfish Detour: OS detour(noise) benchmark
# SELFISHDETOUR:selfishdetour-info
#
# SELFISHDETOUR:selfishdetour-fillin
#      $Id: mk-3dgraph.sh,v 1.9 2007/01/03 21:16:49 kazutomo Exp $
#      SelfishDetour_Version: 1.0.7
#      SelfishDetour_Heredity: FOSS_ORIG
#      SelfishDetour_License: GPL
# SELFISHDETOUR:selfishdetour-fillin
#
# SELFISHDETOUR:selfishdetour-gpl
#       Copyright: Argonne National Laboratory, Department of Energy,
#                  and University of Chicago.  2004, 2005, 2006, 2007
#       SelfishDetour License: GPL
#  
#       This software is free.  See the file license-files/license.GPL
#       for complete details on your rights to copy, modify, and use this
#       software.
# SELFISHDETOUR:selfishdetour-gpl
#***************************************************************************

if [ -z "$1" ] ; then 
  echo "Usage: $0 prefix title"
  exit 1 
fi

datafile=${1}
dataname=`echo ${datafile}|sed -e 's/\.dat$//'` 

if [ ! -f ${datafile} ] ; then
   echo  "could not find ${datafile}"
   exit 1;
fi


title=${dataname}
if [ ! -z "$2" ] ; then
  title=$2
fi

cat - > a.gnu <<EOF

set terminal  postscript 
set output "${dataname}.ps"

set title "$title"

set xlabel "Sync.Freq. [HZ] : logscale"
set ylabel "# Nodes : logscale"
set zlabel "( AV of (max-min) ) / Q "

#set isosamples 100,100
#set samples 100,100

# how do we control dgrid3d?
#set dgrid3d 6,4
set dgrid3d 7,4
#set dgrid3d 8,4
set grid
set pm3d
set view 78, 317, 1.03, 1.03

set logscale x
set logscale y

splot '${datafile}' notitle  w l

repl
repl
EOF

gnuplot a.gnu
rm -f a.gnu

# NOTE: for some reason, convert command generates 
# ${dataname}-0.dat,  ${dataname}-1.dat, ... , instead of ${dataname}.dat
# if the number already exists. convert command uses unused number.
# so increasing the number of files.
# to prevent this problem, just remove all generated files  
rm -f ${dataname}*.png

convert -rotate 90 ${dataname}.ps  ${dataname}.png
rm -f ${dataname}.ps 

